import torch.nn as nn
import torch.nn.functional as F
from os import path
from pathlib import Path

NUM_FEATURES = 41

workspace_path = Path(path.abspath(path.dirname(__file__))) / ".."
model_path = workspace_path / "model"


class LSTM(nn.Module):
    def __init__(self, output_dim=2):
        super().__init__()

        self.rnn = nn.LSTM(
            input_size=NUM_FEATURES, hidden_size=32, batch_first=True, num_layers=8
        )
        self.dropout = nn.Dropout(0.5)
        self.d1 = nn.Linear(32, 10)
        self.d2 = nn.Linear(10, output_dim)

    def forward(self, x):
        out, (hn, cn) = self.rnn(x)
        out = self.dropout(out)
        out = self.d1(out)
        out = F.relu(out)
        out = self.d2(out)

        return out


class CNN(nn.Module):
    pass